use "conor-utils.sml";
use "voodoo.sml";
use "prolog.sml";
use "elim.sml";
use "eq-thms.sml";
use "ind-thms.sml";
use "kjunify.sml";
use "nat-thms.sml";
use "rec-tacs.sml";
use "wave.sml";

signature CONORTOOLS =
sig
  val KJunify : (unit -> unit) ref
  val Clobber : (string -> int -> cnstr -> unit) ref
  val Elim : (string -> int -> cnstr -> unit) ref
  val Induction : (string -> string -> int -> unit) ref
  val Cases : (string -> string -> int -> unit) ref
  val Invert : ((cnstr*cnstr) -> unit) ref
  val KJunifyStep : (unit -> unit) ref
  val Eduardo : (string list -> unit) ref
  val Dale : (unit -> unit) ref
  val SaveReductions : (string list -> unit) ref
  val Wave : (int -> bool -> cnstr_c -> unit) ref
end

structure ConorTools : CONORTOOLS =
struct
  val KJunify = ref LegoKJunify
  val Clobber = ref LegoElim
  val Elim = ref LegoElimKJunify
  val Induction = ref LegoInduction
  val Cases = ref LegoCases
  val Invert = ref LegoInvert
  val KJunifyStep = ref LegoKJunify1
  val Eduardo = ref legoEduardo
  val Dale = ref legoDale
  val SaveReductions = ref legoSaveReductions
  val Wave = ref legoWave
end

