(*<TITLE>conor-sig.sml</TITLE>
<H2>conor-sig.sml</H2>

<XMP>
*)


signature VOODOO =
sig
  type voolabel (* = string * int *)
  datatype voodoo =
    Voo of voolabel               (* herein lies the voodoo *)
  | VProp
  | VTheory                                  (* the type of theories *)
  | VType of node
  | VRef of binding
  | VRel of int                                         (* variable *)
  | VApp of (voodoo * (voodoo list)) * (prntVisSort list) (* application *)
  | VBind of bindVisSort * string * voodoo * voodoo
  | VVar of int * voodoo                      (* existential variable *)
  | VTuple of voodoo * (voodoo list)           (* elem of Sig *)
  | VProj of projSort * voodoo
  | VLabVT of label * voodoo * voodoo          (* labeled trm:typ pair *)
  | VCnLst of voodoo list                     (* for use in Theories *)
  | VRedTyp of instrs * voodoo   (* reduce the synthesised type using insts *)
  | VCase of voodoo * voodoo        (* case *)
  | VBot
  type voobind (* = voolabel * bindVisSort * string * voodoo *)
  type vooctxt (* = voobind list *)
  type voostate (* = vooctxt * voodoo *)
  exception too_much_voodoo
  exception missing_voodoo
  exception voodoo_no_rewrite
  val voofold : 'a -> (voolabel -> 'a) -> ('a -> 'a -> 'a) -> voodoo -> 'a
  val voomap : (voolabel -> voodoo) -> voodoo -> voodoo
  val start : cnstr -> voostate
  val introvoo : string -> int -> voostate -> voostate
  val introvool : string list -> int -> int -> voostate -> voostate
  val voo : cnstr -> voodoo
  val unvoo : voodoo -> cnstr
  val stop : voostate -> cnstr
  val outrovoo : voostate -> voodoo
  val vootype : voodoo -> voodoo
  val voorewrite : (voodoo->voodoo)->voodoo->voodoo
  val vooleftmost : (voodoo->voodoo)->voodoo->voodoo
  val voonormal : (voodoo->voodoo)->voodoo->voodoo
  val vooelse : (voodoo->voodoo) list->voodoo->voodoo
  val voolift : (voodoo->voodoo)->voostate->voostate
  val voosub : voolabel -> voodoo -> voostate -> voostate
  val liftrels : int -> voodoo -> voodoo
  val relsub  : voolabel -> voodoo -> int -> voodoo -> voodoo
  val voobeta  : voodoo -> voodoo list -> prntVisSort list -> voodoo
  val voooccur  : voolabel -> voodoo -> bool
  val vooeta  : voodoo -> voodoo
  val shove : voobind -> voolabel -> voostate -> voostate
  val fetch : voolabel -> voostate -> voobind
  val swap : voobind -> voostate -> voostate
  val elide : voolabel -> voostate -> voostate
  val dep1l : voodoo -> voolabel list
  val dep1g : vooctxt -> voolabel -> voolabel list
  val deple : vooctxt -> voolabel -> voolabel list
  val vooprint : voodoo -> unit
  val vooprintstate : voostate -> unit
end

signature CONORQNIFY =
sig
  type cnstr_c
  val cleverClobberFlag : bool ref
  val ClobberTac : cnstr_c -> int -> cnstr_c -> unit
  val ElimTac : cnstr_c -> int -> unit
  val InvertTac : cnstr_c -> int -> unit
  val InitialiseQnify : unit -> unit
  exception noQnify
  val KJunifyTac : int -> unit
end

signature CONORREQUIRE =
sig
  exception RequireFailure
  val Memo                : string list -> ((cnstr * cnstr) * bool)
  val RequireFail         : string list -> ((cnstr * cnstr) * bool)
  val AddRequireDemon     : (string list -> ((cnstr * cnstr) * bool)) -> unit
  val Require             : string list -> (cnstr * cnstr)
  val ConfigMemo          : (string list * string) -> unit
  val RequireTac          : string list -> unit
  val tagName             : string list -> string
(* *)
  val requireDemons : (string list -> ((cnstr * cnstr) * bool)) list ref
(* *)
end


(*
</XMP>
*)

